appControllers.controller('Suchspiel', function($scope,  $ionicPlatform, $cordovaMedia, $state, $timeout,$q) {


$scope.showmentor=false;
$scope.showmentorbravo=false;
$scope.spiele=[];
$scope.spielelistensort=[];

$scope.spieleview=[];
$scope.tierfinden='';
$scope.randomid=0;
$scope.error = false;
$scope.spielrunden=0;
$scope.falscheantwort=0;
$scope.cardindex=0;

$scope.errorcode=99;
$scope.tierindex=99;
$scope.spielfertig=-1;
$scope.spielneu=-1;


$ionicPlatform.ready(function() {
 
  /*
  * Sounds definieren
  */
  $scope.sounds=[];
  //$scope.sounds.push('');


  var tiersound1 =  new Media('/android_asset/www/sounds/finde_elefant.mp3', mentorausblenden,null);
  var tiersound2 =  new Media('/android_asset/www/sounds/finde_esel.mp3', mentorausblenden,null);
  var tiersound3 =  new Media('/android_asset/www/sounds/finde_hahn.mp3', mentorausblenden,null);
  var tiersound4 =  new Media('/android_asset/www/sounds/finde_hund.mp3', mentorausblenden,null);
  var tiersound5 =  new Media('/android_asset/www/sounds/finde_katze.mp3', mentorausblenden,null);
  var tiersound6 =  new Media('/android_asset/www/sounds/finde_kuh.mp3', mentorausblenden,null);
  var tiersound7 =  new Media('/android_asset/www/sounds/finde_maus.mp3', mentorausblenden,null);
  var tiersound8 =  new Media('/android_asset/www/sounds/finde_schaf.mp3', mentorausblenden,null);

  var bravosound = new Media('/android_asset/www/sounds/bravo.mp3', karteausblenden,null);
  var falschsound = new Media('/android_asset/www/sounds/falsch.mp3', null,null);

  var kartegebensound =  new Media('/android_asset/www/sounds/karte.mp3', kartegeben,null);

  $scope.bravosound=bravosound;
  $scope.falschsound=falschsound;
  $scope.kartegebensound=kartegebensound;

  $scope.sounds.push(tiersound1);
  $scope.sounds.push(tiersound2);
  $scope.sounds.push(tiersound3);
  $scope.sounds.push(tiersound4);
  $scope.sounds.push(tiersound5);
  $scope.sounds.push(tiersound6);
  $scope.sounds.push(tiersound7);
  $scope.sounds.push(tiersound8);

});


/*
* Tiere definieren
*/
var tier = {
  id: 0,
  bild: 'elefant.jpg',
  sound1: 'sound_elefant.mp3',
  antwort: '',
  display: false,
  einblendecssid: 'elefantein',
  ausblendecssid: 'elefantaus',
  sortid: 0
};
$scope.spiele.push(tier);


var tier1 = {
  id: 1,
  bild: 'esel.jpg',
  sound1: 'sound_esel.mp3',
  antwort: '',
  display: false,
  einblendecssid: 'eselein',
  ausblendecssid: 'eselaus',
  sortid: 0
};
$scope.spiele.push(tier1);


var tier2 = {
  id: 2,
  bild: 'hahn.jpg',
  sound1: 'sound_hahn.mp3',
  antwort: '',
  display: false,
  einblendecssid: 'hahnein',
  ausblendecssid: 'hahnaus',
  sortid: 0
};
$scope.spiele.push(tier2);


var tier3 = {
  id: 3,
  bild: 'hund.jpg',
  sound1: 'sound_hund.mp3',
  sound2: '',
  display: false,
  einblendecssid: 'hundein',
  ausblendecssid: 'hundaus',
  sortid: 0
};
$scope.spiele.push(tier3);


var tier4 = {
  id: 4,
  bild: 'katze.jpg',
  sound1: 'sound_katze.mp3',
  sound2: '',
  display: false,
  einblendecssid: 'katzeein',
  ausblendecssid: 'katzeaus',
  sortid: 0
};
$scope.spiele.push(tier4);


var tier5 = {
  id: 5,
  bild: 'kuh.jpg',
  sound1: 'sound_kuh.mp3',
  sound2: '',
  display: false,
  einblendecssid: 'kuhein',
  ausblendecssid: 'kuhaus',
  sortid: 0
};
$scope.spiele.push(tier5);


var tier6 = {
  id: 6,
  bild: 'maus.jpg',
  sound1: 'sound_maus.mp3',
  sound2: '',
  display: false,
  einblendecssid: 'mausein',
  ausblendecssid: 'mausaus',
  sortid: 0
};
$scope.spiele.push(tier6);


var tier7 = {
  id: 7,
  bild: 'schaf.jpg',
  sound1: 'sound_schaf.mp3',
  sound2: '',
  display: false,
  einblendecssid: 'schafein',
  ausblendecssid: 'schafaus',
  sortid: 0
};
$scope.spiele.push(tier7);

/*
* Wiederholung der Aufgabe
*/
$scope.hilfe = function() {
  $scope.showmentor=true;
  $scope.sounds[$scope.randomid].play();
}


/*
* Mentor ausblenden
*/
function mentorausblenden(){
  $timeout(function () { $scope.showmentor=false; $scope.cardindex=-1}, 10);

}


/*
* Antwort prüfen
*/
$scope.answer = function(src) {

  if (src==$scope.randomid){
    $timeout(function () { $scope.showmentorbravo=true;$scope.cardindex=0; }, 0);
    $scope.bravosound.play();
  }
  else{
    
    //$scope.spiele[$scope.randomid].errorcode=true;
    if ($scope.falscheantwort==2){
      $scope.errorcode=$scope.randomid;
      $scope.error = false;
      $timeout(function () {
        $scope.errorcode=99;
        $timeout(function () {
          $scope.errorcode=$scope.randomid;
          $timeout(function () { $scope.cardindex=0;karteausblenden(); }, 2400);
        }, 1400);
      }, 700);

    }
    else {
      $scope.falschsound.play();
      $scope.error = true;
      $timeout(function () {
        $scope.error = false;
        $scope.falscheantwort=$scope.falscheantwort + 1
      }, 1000);



    }

  }

}


/*
* Neues Spiel
*/
function goto_newspiel(){
  $scope.errorcode=99;
  $scope.falscheantwort=0;
  $scope.spielneu=0;
  $scope.cardindex=-1;

  kartenmischen();
  
  $timeout(function () {  $scope.kartegebensound.play(); }, 2000);
}


function kartegeben(){


  $timeout(function () { 
    $scope.cardindex=$scope.cardindex + 1;
    $scope.spielelistensort[$scope.cardindex].display=true;
    
    for(var i = 0; i < $scope.spiele.length; i++) {
      var data= $scope.spiele[i];
      if (data.id==$scope.spielelistensort[$scope.cardindex].id){
        $scope.spielneu=data.einblendecssid;
      }
    }

  }, 0);
  
  
  if ($scope.cardindex < 6 ){
    $scope.kartegebensound.play();
  }
  else{
    $scope.spielneu='';
    $scope.randomid=getRandomInt(0, 7);
    $scope.showmentor=true;
    $scope.sounds[$scope.randomid].play();
  }

  
  
}


function karteausblenden(){
  $timeout(function () {  $scope.showmentorbravo=false; }, 0);

  if ($scope.cardindex < 8 ){

    for(var i = 0; i < $scope.spiele.length; i++) {
      var data= $scope.spiele[i];
      if (data.id==$scope.spielelistensort[$scope.cardindex].id){
        $scope.spielfertig=data.ausblendecssid;
      }
    }
    $timeout(function () { 
      $scope.spielelistensort[$scope.cardindex].display=false; 
      $scope.chunkedData = chunk($scope.spielelistensort, 4);
      $scope.cardindex=$scope.cardindex + 1;
      karteausblenden(); 
    }, 500);
  }
  else{
   $scope.spielfertig='';
   goto_newspiel(); 
  }
  

  
}

/*
* Drei mal mischen :)
*/
function kartenmischen(){
  $scope.spiele=shuffleArray($scope.spiele);
  $scope.spiele=shuffleArray($scope.spiele);
  $scope.spiele=shuffleArray($scope.spiele);

  $scope.spielelistensort=[];
  for(var i = 0; i < $scope.spiele.length; i++) {
    var data= $scope.spiele[i];
    data.sortid=i;
    $scope.spielelistensort.push(data);
  }
  $scope.tierindex=$scope.spiele.length + " - " + $scope.spielelistensort.length;
  $scope.chunkedData = chunk($scope.spielelistensort, 4);
}




/*
* Per Zufall neue Aufgabe definieren
*/
function getRandomInt(min, max) {
  var tmpInt=0;
  min = Math.ceil(min);
  max = Math.floor(max);
  tmpInt = Math.floor(Math.random() * (max - min + 1)) + min; 

  if (tmpInt > max){
    tmpInt=max;
  }

  if (tmpInt < min){
    tmpInt=min;
  }

  return tmpInt;
}

/*
* TierArray per Zufall mischen
*/
var shuffleArray = function(array) {
  var m = array.length, t, i;

  // While there remain elements to shuffle
  while (m) {
    // Pick a remaining element…
    i = Math.floor(Math.random() * m--);

    // And swap it with the current element.
    t = array[m];
    array[m] = array[i];
    array[i] = t;
  }

  return array;
}

/*
* TierArray nach x Spalten Aufteilen (Darstellung)
*/
function chunk(arr, size) {
  var newArr = [];
  for (var i=0; i<arr.length; i+=size) {
    newArr.push(arr.slice(i, i+size));
  }
  return newArr;
}
//$scope.chunkedData = chunk($scope.spiele, 4);

/*
* Initial - Neues Spiel starten
*/
$scope.inittimercounter=3;
$scope.showinittimer=true;
$timeout(function () { inittimer(); }, 1000);

function inittimer(){
  
  if ($scope.inittimercounter > 0){

    $timeout(function () {  
      $scope.inittimercounter=$scope.inittimercounter - 1;
      inittimer();
    }, 1000);

  }
  else{
    $scope.showinittimer=false;
    goto_newspiel();
  }
}


});